#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TurretCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TurretCFG> Fish_TurretCFG::msSingleton(nullptr);

int Fish_TurretCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretCFGData* Fish_TurretCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TurretCFGData>& Fish_TurretCFG::GetMapData()
{
	return mMapData;
}

void Fish_TurretCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TurretCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mColor = element->IntAttribute("Color");
		data.mSoundID = element->IntAttribute("SoundID");
		data.mFireEffectID = element->IntAttribute("FireEffectID");
		data.mEffectOffsetY = element->IntAttribute("EffectOffsetY");
		data.mOffsetY = element->IntAttribute("OffsetY");
		data.mFireOffsetY = element->IntAttribute("FireOffsetY");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TurretCFG::Load()
{
	Load("../Config/Fish_TurretCFG.xml");
}

Fish_TurretCFG* Fish_TurretCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretCFG());
	}
	return msSingleton.get();
}
